#ifndef _TOPFIELD_H_
#define _TOPFIELD_H_
//----------------------------------------------------------------------------
//
//a bunch of topfield firmware specific stuff
//

//----------------------------------------------------------------------------
//
//tap.h extensions
//
#define pLoaderVersion  0xa3fffff8
#define pSysID          0xa3fffffa
extern word fw_sysid;
extern int _appl_version;
extern char *tap_name;

#define ptrfix(p) (p + _tap_startAddr)
typedef void (*funcVoid)(void);
typedef int (*funcInt)(void);

extern int __tap_Header__;
extern int __startPoint;
extern int _initData;
//extern int TAP_Main;
extern int _tap_gotStart;
extern int _tap_gotEnd;
extern int _tap_textEnd;
extern int _tap_fixupStart;
extern int _tap_fixupEnd;
//extern int TAP_EventHandler;
extern int _gp;
extern int _end;
//----------------------------------------------------------------------------
//
//local key defines (missing in key.h)
//
#define RKEY_TvSTB      0x10022       //was RKEY_TvSat
#define RKEY_Opt        0x10010

#define RKEY_List       0x10018       //shared with RKEY_TvRadio

#define RKEY_Right      0x10015       //shared with RKEY_VolUp
#define RKEY_Left       0x1000f       //shared with RKEY_VolDown
#define RKEY_Up         0x10012       //shared with RKEY_ChUp
#define RKEY_Down       0x1001d       //shared with RKEY_ChDown

#define RKEY_SubMove    0x10041
#define RKEY_FileList   0x10042       //or RKEY_PlayList
#define RKEY_Text       0x10043

#define RKEY_Red        0x1003f
#define RKEY_Green      0x10024
#define RKEY_Yellow     0x10025
#define RKEY_Blue       0x10026

#define RKEY_White      0x1003e
#define RKEY_SubSwap    0x10040

//unmapped key values
#define exRKEY_TvRadio  0x1000e       //0x10018 (RKEY_List)    remapped to 0x1000e (RKEY_Uhf)
#define exRKEY_Exit     0x10013       //0x10017 (RKEY_VolDown) remapped to 0x10013 (RKEY_AudioTrk)

#define exRKEY_VolUp    0x10020       //0x10015 (RKEY_Right)   remapped to 0x10020 (RKEY_Fav )
#define exRKEY_VolDown  0x10017       //0x1000f (RKEY_Left)    remapped to 0x10017 (RKEY_Exit)
#define exRKEY_ChUp     0x10021       //0x10012 (RKEY_Up)      remapped to 0x10021 (RKEY_Subt)
#define exRKEY_ChDown   0x10037       //0x1001d (RKEY_Down)    remapped to 0x10037 (RKEY_Teletext)

//----------------------------------------------------------------------------
//hdd.h extensions
#define ATTR_DOTDOT 	0xf0
#define ATTR_DOT        0xf1
#define ATTR_FOLDER 	0xf2
#define ATTR_RECYCLE 	0xf3

//----------------------------------------------------------------------------
//
//this is the internal data structure used to store events
//it _always_ starts at address FW_EVENT_TABLE
//what are the unknown values ???
//how is the event_name, extended_event_name allocated ???
//note that the extended_event_name is a list of (num_extended) zero terminated (name,description) pairs
//with a total length of extended_length  The final pair is terminated with another 0 (i.e. 2 0's indicate end of list)
//
typedef struct{
    byte  char00;                   //00    // top 2 bits - valid; lower 5 bits - running status
                                            //pre 1288: top 2 bits = valid, next 1 bit = ???, next 5 bits = running status,
                                            //for 1288: top 2 bits = valid, next 3 bits = running status, next 3 = ???
//    byte  char00a:2;                //00
//    byte  char00b:1;                //00
//    byte  running_status:5;         //00
    byte  char01;                   //01
    byte  duration_hour;            //02
    byte  duration_min;             //03
    word  short04;                  //04    //??? normally 0000
    word  event_id;                 //06
    word  start_date;               //08    //mjd, utc time
    byte  start_hour;               //0a
    byte  start_min;                //0b
    word  end_date;                 //0c    //mjd, utc time
    byte  end_hour;                 //0e
    byte  end_min;                  //0f
    byte  event_name_length;        //10
    byte  parental_rating;          //11
    word  original_network_id;      //12
    word  transport_stream_id;      //14
    word  service_id;               //16
    word  short18;                  //18    //??? normally 0000
    word  sat_index;                //1a
    word  short1c;                  //1c    //??? normally 0000
    word  short1e;                  //1e    //??? normally 0000    or 6500
    word  short20;                  //20    //??? normally 0000
    word  previous;                 //22    //previous, a link to the previous epg entry, by date/time, ffff terminates
    word  short24;                  //24    //??? normally 0000
    word  next;                     //26    //next, a link to the previous epg entry, by date/time, ffff terminates
    byte  *event_name;              //28    //ptr to event name, event description is offset by event_name_length bytes
//<12.88
    byte  char2c;                   //2c    //01 if extended present else 00
    byte  num_extended;             //2d    //number of extended items
    word  extended_length;          //2e    //extended length
    byte  *extended_event_name;     //30
//v12.88
//    byte  *extended_event_name;     //2c
//    byte  char30;                   //30    //01 if extended present else 00
//    byte  num_extended;             //31    //number of extended items
//    word  extended_length;          //32    //extended length

    word  short34;                  //34    //0001 if extended present else 0000
    word  short36;                  //36    //0001 if extended present else 0000
    word  date_added;               //38    //mjd, utc time - date added ?
    word  short3a;                  //3a    //??? normally 0000
    word  short3c;                  //3c    //??? normally 0000
    word  short3e;                  //3e    //??? normally 0000

    //for fw:1288, this is 0x44 byte long
    byte  content_nibble1;          //40
    byte  content_nibble2;          //41
    word  short42;                  //42    //user_nibble1,2? - not filled in by fw?

}type_eventtable;

//----------------------------------------------------------------------------
//
//this is the internal table that holds pointers to the event name/description buffers
//
//note, from 1288, only the first buffer is used for both short and extended data
//
typedef struct {
    byte *short_event_buffer;
    dword short_event_blocks;
    dword s2;
    dword s3;
    byte *extended_event_buffer;
    dword extended_event_blocks;
    dword e2;
    dword e3;
} type_eventbuffer;

//----------------------------------------------------------------------------
typedef struct{
    dword magic;                //00   TFrc
    word  version;              //04   5010    //version
    word  word_ae;              //06   0000
    word  fduration;            //08   0001    //file duration (mins)???
    word  svcNum;               //0a   000d        //lcn   (always 0 )
    word  svcType;              //0c   0000

    word  word_b6;              //0e   0000
    word  word_b8;              //10   04b0        //tuner
    word  service_id;           //12   20fa
    word  pmt_pid;              //14   010e
    word  pcr_pid;              //16   1ffe
    word  video_pid;            //18   024e
    word  audio_pid;            //1a   824f        // | 0x8000
    byte  channel_name[0x1c];   //1c   More 4

    word  uhf_channel;          //30   0016
    byte  bandwidth;            //3a   08
    byte  byte_e3;              //3b   00
    dword frequency;            //3c   00075ad0
    word  transport_stream_id;  //40   2005
    byte  lphp_stream;          //42   00  0=lp,1=hp
    byte  byte_eb;              //43   00
    word  original_network_id;  //44   233a
    word  word_ee;              //46   3005

    word  word_f0;              //48   8000
    word  duration;             //4a   0123     //epg duration hr:min
    word  word_f4;              //4c   0000
    word  event_id;             //4e   793e
    dword startTime;            //50   d2b9151e
    dword endTime;              //54   d2b91705
    byte  runningStatus;        //58   04
    byte  eventName_length;     //59   03
    byte  parental_rating;      //5a   00
    byte  eventName_description[0x100];   //5b GBHThe only ray of ...
    byte  padding[0xf00];       //
}type_rec_header;

//81B57F40
typedef struct{
    byte  playMode;             //00      03, 02
    byte  byte_01;              //01      00          :d[4:3] - recording slots active?
    byte  byte_02;              //02      00
    byte  byte_03;              //03      00, 03
    dword trickMode;            //04      00000000
    dword speed;                //08      00000001
    dword dword_0c;             //0c      00000001
    dword dword_10;             //10      start time, (mjd,hr,min)
    dword dword_14;             //14      03000000
    dword dword_18;             //18      00005f2f
    dword dword_1c;             //1c      000000b0
    dword dword_20;             //20      001be800
    byte  filename[0x40];       //24
    byte  channel_name[0x1c];   //64
    dword dword_80;             //80      00000080
    dword dword_84;             //84      00000000
    dword dword_88;             //88      00000000
    dword dword_8c;             //8c      22000000
    dword dword_90;             //90      82018edc
    dword dword_94;             //94      e812c6ae
    dword dword_98;             //98      00000000
    dword dword_9c;             //9c      18201800
    dword dword_a0;             //a0      00000000
    dword dword_a4;             //a4      d87d86b7
    type_rec_header rec;        //a8
}type_play_info;

//0x81C9CF98
typedef struct{
    byte  recType;              //00
    byte  byte_01;              //01    22,68,          tuner     trickmode
    byte  byte_02;              //02                    rsvd      speed
    byte  byte_03;              //03                    svcType
    word  duration;             //04
    word  chNum;                //06    chnum     ?
    dword dword_08;             //08    start time(mjd,hr,min)
    dword dword_0c;             //0c    ens   time(mjd,hr,min)
    word  word_10;              //10    chtype?
    word  service_id;           //12
    char  filename[0x40];       //14
    dword dword_54;             //54
    dword dword_58;             //58
    dword dword_5c;             //5c
    dword dword_60;             //60
    word  word_64;              //64
    word  pmt_pid;              //66
    dword dword_68;             //68
    dword dword_6c;             //6c
    dword dword_70;             //70
    dword dword_74;             //74
    word  uhf_channel;          //78
    byte  bandwidth;            //7a
    byte  byte_7b;              //7b    00
    dword frequency;            //7c
    word  transport_stream_id;  //80
    word  word_82;              //82    0000 ???
    word  original_network_id;  //84
    word  word_86;              //86    3005 ???
}type_rec_info;                 //88

typedef struct{
    word  service_id;           //00
    word  video_pid;            //02
    word  audio_pid;            //04    (|0x8000, top bit set)
    word  pcr_pid;              //06
    word  transport_stream_id;  //08
    word  original_network_id;  //0a
    word  pmt_pid;              //0c
    word  word_0e;              //0e    0018=     0012=
    byte  byte_10;              //10    00
    byte  byte_11;              //11    00            |04
    word  word_12;              //12    0001
}type_channel_info;

//----------------------------------------------------------------------------
typedef struct {
    word    mjd;
    byte    hour;
    byte    minute;
}type_taptime;

//----------------------------------------------------------------------------
//
//tap load structures
//
typedef struct
{
    byte signature[32];					//TFAMIPS
    dword id;
    byte padding1[28];
    const char name[MAX_PROGRAM_NAME];
    const char authorName[MAX_AUTHOR_NAME];
    const char description[MAX_DESCRIPTION];
    const char etcStr[MAX_ETCINFO_STR];
} type_TAPHeader;

typedef struct
{
    // From libtap.a                                               12.88
    dword _initData;                                      //  00   827b37c4
    void *TAP_Main;                                       //  04   827a8b68
    dword _tap_gotStart;                                  //  08   00020be0
    dword _tap_gotEnd;                                    //  0c   000210f4
    dword _tap_textEnd;                                   //  10   0000c970
    dword _tap_fixupStart;                                //  14   000210ec
    dword _tap_fixupEnd;                                  //  18   000210f0
    void *TAP_EventHandler;                               //  1c   827a8d30
    dword _gp;                                            //  20   00020be0
    dword _end;                                           //  24   000246c0
                                                          //
    void *pTAP_SystemProc;                                //  28   80177a54
    void *_appl_version;                                  //  2c   00001288
    void *null30;                                         //  30   00000000
    void *pTAP_GetState;                                  //  34   801779a4
    void *pTAP_ExitNormal;                                //  38   80177684
    void *pTAP_EnterNormal;                               //  3c   80177720
    void *null40;                                         //  40   00000000
    void *null44;                                         //  44   00000000
    void *pTAP_Exit;                                      //  48   801777ac
    void *pTAP_KbHit;                                     //  4c   80177278
    void *pTAP_GetCh;                                     //  50   8017730c
    void *pTAP_PutCh;                                     //  54   801773a0
    void *pTAP_Print;                                     //  58   80177538
    void *pTAP_GetSystemProc;                             //  5c   8018117c
    void *pTAP_undoc11;                                   //  60   80181208  undocumented  void TAP_Set_undoc11(int mode, int enable);      enables osd banners
    void *pTAP_SetBaudRate;                               //  64   801813a4
    void *pTAP_PutByte;                                   //  68   8017742c
    void *pTAP_PrintSys;                                  //  6c   80177494
    //etc
    void *null70;                                         //  70   00000000
    void *null74;                                         //  74   00000000
    void *null78;                                         //  78   00000000
    void *null7c;                                         //  7c   00000000
    void *null80;                                         //  80   00000000
    void *pTAP_SetSoundLevel;                             //  84   80177f10
    void *pTAP_GetTim;                                    //  88   80177f9c
    void *pTAP_MemInfo;                                   //  8c   80177c60
    void *pTAP_MemAlloc;                                  //  90   80177d44
    void *pTAP_MemFree;                                   //  94   80177e4c
    void *pTAP_GetTick;                                   //  98   80178038
    void *pTAP_Delay;                                     //  9c   801780cc
    void *pTAP_ExtractMjd;                                //  a0   80178158
    void *pTAP_MakeMjd;                                   //  a4   80178200
    void *pTAP_Sin;                                       //  a8   8017829c
    void *pTAP_Cos;                                       //  ac   80178330
    void *pTAP_SPrint;                                    //  b0   801775e4
    void *pTAP_GetSignalLevel;                            //  b4   801783c4
    void *pTAP_GetSignalQuality;                          //  b8   80178498
    void *pTAP_SetInfoboxTime;                            //  bc   80178530
    void *pTAP_PlayPCM;                                   //  c0   80178fdc
    void *pTAP_CaptureScreen;                             //  c4   801785ec
    void *pTAP_GetSystemVar;                              //  c8   80178c38
    void *pTAP_SetSystemVar;                              //  cc   801786d8
    void *pTAP_WriteSystemVar;                            //  d0   80178e68
    void *pTAP_GenerateEvent;                             //  d4   80179084
    void *nulld8;                                         //  d8   00000000
    void *pTAP_Osd_Create;                                //  dc   80179154
    void *pTAP_Osd_Delete;                                //  e0   801793a4
    void *pTAP_Osd_Move;                                  //  e4   80179574
    void *pTAP_Osd_FillBox;                               //  e8   80179658
    void *pTAP_Osd_PutBox;                                //  ec   80179770
    void *pTAP_Osd_GetBox;                                //  f0   801798a0
    void *pTAP_Osd_SetLut;                                //  f4   801799c0
    void *pTAP_Osd_Ctrl;                                  //  f8   80179aa4
    void *pTAP_Osd_SetTransparency;                       //  fc   80179b6c
    void *pTAP_Osd_Draw3dBox;                             // 100   80179c2c
    void *pTAP_Osd_Draw3dBoxFill;                         // 104   80179d48
    void *pTAP_Osd_DrawRectangle;                         // 108   80179e6c
    void *pTAP_Osd_PutGd__;                               // 10c   80179f8c
    void *pTAP_Osd_DrawPixmap;                            // 110   8017a090
    void *pTAP_Osd_Zoom;                                  // 114   8017a1b8
    void *pTAP_Osd_GetBaseInfo;                           // 118   8017a380
    void *pNullsub11c;                                    // 11c   80176f58
    void *pNullsub120;                                    // 120   80176f58
    void *pNullsub124;                                    // 124   80176f58
    void *pTAP_Osd_Copy;                                  // 128   8017a638
    void *pTAP_Osd_SaveBox;                               // 12c   8017a768
    void *pTAP_Osd_RestoreBox;                            // 130   8017a878
    void *pTAP_Osd_GetPixel;                              // 134   8017a988
    void *pTAP_Osd_PutPixel;                              // 138   8017aa7c
    void *pNullsub13c;                                    // 13c   80176f58
    void *null140;                                        // 140   00000000
    void *null144;                                        // 144   00000000
    void *null148;                                        // 148   00000000
    void *null14c;                                        // 14c   00000000
    void *null150;                                        // 150   00000000
    void *null154;                                        // 154   00000000
    void *null158;                                        // 158   00000000
    void *null15c;                                        // 15c   00000000
    void *null160;                                        // 160   00000000
    void *null164;                                        // 164   00000000
    void *pTAP_Hdd_Fopen;                                 // 168   8017ab70
    void *pTAP_Hdd_Fread;                                 // 16c   8017ae38
    void *pTAP_Hdd_Fwrite;                                // 170   8017af30
    void *pTAP_Hdd_Fclose;                                // 174   8017ac6c
    void *pTAP_Hdd_FindFirst;                             // 178   8017b028
    void *pTAP_Hdd_FindNext;                              // 17c   8017b0f4
    void *pTAP_Hdd_Fseek;                                 // 180   8017b1c0
    void *pTAP_Hdd_Flen;                                  // 184   8017b2a8
    void *pTAP_Hdd_Ftell;                                 // 188   8017b368
    void *pTAP_Hdd_TotalSize;                             // 18c   8017b428
    void *pTAP_Hdd_FreeSize;                              // 190   8017b4e4
    void *pTAP_Hdd_Delete;                                // 194   8017ad38
    void *pTAP_Hdd_Exist;                                 // 198   8017b5a0
    void *pTAP_Hdd_Create;                                // 19c   8017b664
    void *pTAP_Hdd_ChangeDir;                             // 1a0   8017b73c
    void *pTAP_Hdd_PlayTs;                                // 1a4   8017b81c
    void *pTAP_Hdd_StopTs;                                // 1a8   8017b8e0
    void *pTAP_Hdd_PlayMp3;                               // 1ac   8017b9f4
    void *pTAP_Hdd_StopMp3;                               // 1b0   8017bab4
    void *pTAP_Hdd_Rename;                                // 1b4   8017bbec
    void *pTAP_Hdd_StartRecord;                           // 1b8   8017bcc8
    void *pTAP_Hdd_StopRecord;                            // 1bc   8017bd60
    void *pTAP_Hdd_GetRecInfo;                            // 1c0   8017be2c
    void *pTAP_Hdd_GetPlayInfo;                           // 1c4   8017c078
    void *pTAP_Hdd_GetHddID;                              // 1c8   8017c828
    void *pTAP_Osd_PutS;                                  // 1cc   8017c890
    void *pTAP_Osd_GetW;                                  // 1d0   8017c9c8
    void *pTAP_Osd_PutString;                             // 1d4   8017ca5c
    void *pTAP_Osd_DrawString;                            // 1d8   8017cb98
    void *pTAP_Osd_PutStringAf;                           // 1dc   8017cc5c
    void *pTAP_Win_SetTitle;                              // 1e0   8017cd8c
    void *pTAP_Win_SetColor;                              // 1e4   8017ce18
    void *pTAP_Win_SetDefaultColor;                       // 1e8   8017cefc
    void *pTAP_Win_Draw;                                  // 1ec   8017cf88
    void *pTAP_Win_Create;                                // 1f0   8017d014
    void *pTAP_Win_Delete;                                // 1f4   8017d120
    void *pTAP_Win_SetFont;                               // 1f8   8017d1c8
    void *pTAP_Win_AddItem;                               // 1fc   8017d254
    void *pTAP_Win_GetSelection;                          // 200   8017d2e4
    void *pTAP_Win_SetSelection;                          // 204   8017d378
    void *pTAP_Win_Action;                                // 208   8017d404
    void *null20c;                                        // 20c   00000000
    void *null210;                                        // 210   00000000
    void *null214;                                        // 214   00000000
    void *null218;                                        // 218   00000000
    void *null21c;                                        // 21c   00000000
    void *pTAP_Channel_StopMainSub;                       // 220   8017d5f4  undocumented  int  exTAP_Channel_StopMainSub(void);
    void *pTAP_nullsub224;                                // 224   8017d694  undocumented  void exTAP_TAP_nullsub3(void);
    void *pTAP_nullsub228;                                // 228   8017d6fc  undocumented  void exTAP_TAP_nullsub4(void);
    void *pTAP_nullsub22c;                                // 22c   8017d764  undocumented  void exTAP_TAP_nullsub5(void);
    void *pTAP_nullsub230;                                // 230   8017d7cc  undocumented  void exTAP_TAP_nullsub6(void);
    void *pTAP_nullsub234;                                // 234   8017d834  undocumented  void exTAP_TAP_nullsub7(void);
    void *pTAP_nullsub238;                                // 238   8017d89c  undocumented  void exTAP_TAP_nullsub8(void);
    int  *pTAP_nullsub23c;                                // 23c   8017d904  undocumented  int  exTAP_TAP_nullsub9(void);
    void *pTAP_nullsub240;                                // 240   8017d96c  undocumented  void exTAP_TAP_nullsub10(void);
    void *null244;                                        // 244   00000000
    void *null248;                                        // 248   00000000
    void *null24c;                                        // 24c   00000000
    void *null250;                                        // 250   00000000
    void *null254;                                        // 254   00000000
    void *null258;                                        // 258   00000000
    void *null25c;                                        // 25c   00000000
    void *null260;                                        // 260   00000000
    void *null264;                                        // 264   00000000
    void *null268;                                        // 268   00000000
    void *pTAP_Channel_GetTotalNum;                       // 26c   8017d9d4
    void *pTAP_Channel_GetFirstInfo;                      // 270   8017da4c
    void *pTAP_Channel_GetNextInfo;                       // 274   8017dfe4
    void *pTAP_Channel_GetInfo;                           // 278   8017e0bc
    void *pTAP_Channel_GetCurrent;                        // 27c   8017e180
    void *pTAP_Channel_Start;                             // 280   8017e290
    void *pTAP_Channel_Scale;                             // 284   8017e448
    void *pTAP_Channel_IsPlayable;                        // 288   8017e500
    void *pTAP_Channel_Move;                              // 28c   8017e5d4
    void *pTAP_Channel_Stop;                              // 290   8017e38c
    void *pTAP_Channel_GetTotalAudioTrack;                // 294   8017e668
    void *pTAP_Channel_GetAudioTrackName;                 // 298   8017e6d8
    void *pTAP_Channel_SetAudioTrack;                     // 29c   8017e7b8
    void *pTAP_Channel_GetTotalSubtitleTrack;             // 2a0   8017e864
    void *pTAP_Channel_GetSubtitleTrackName;              // 2a4   8017e8d4
    void *pTAP_Channel_SetSubtitleTrack;                  // 2a8   8017e9b4
    void *pTAP_Channel_GetCurrentSubTV;                   // 2ac   8017e21c
    void *null2b0;                                        // 2b0   00000000
    void *null2b4;                                        // 2b4   00000000
    void *null2b8;                                        // 2b8   00000000
    void *null2bc;                                        // 2bc   00000000
    void *null2c0;                                        // 2c0   00000000
    void *null2c4;                                        // 2c4   00000000
    void *null2c8;                                        // 2c8   00000000
    void *null2cc;                                        // 2cc   00000000
    void *null2d0;                                        // 2d0   00000000
    void *pTAP_GetEvent;                                  // 2d4   8017f728
    void *pTAP_GetCurrentEvent;                           // 2d8   8017fc08
    void *pTAP_PutEvent;                                  // 2dc   8017feac
    void *null2e0;                                        // 2e0   00000000
    void *null2e4;                                        // 2e4   00000000
    void *pTAP_Timer_GetTotalNum;                         // 2e8   80180420
    void *pTAP_Timer_GetInfo;                             // 2ec   801804c4
    void *pTAP_Timer_Add;                                 // 2f0   80180624
    void *pTAP_Timer_Modify;                              // 2f4   801806f0
    void *pTAP_Timer_Delete;                              // 2f8   80180b3c
    void *null2fc;                                        // 2fc   00000000
    void *null300;                                        // 300   00000000
    void *pTAP_Usb_Read;                                  // 304   8017eea8
    void *pTAP_Usb_Write;                                 // 308   8017ef44
    void *pTAP_Usb_PacketRead;                            // 30c   8017efe0
    void *pTAP_Usb_PacketWrite;                           // 310   8017f07c
    void *pTAP_Usb_Cancel;                                // 314   8017f118
    void *null318;                                        // 318   00000000
    void *null31c;                                        // 31c   00000000
} type_TAPEntryPoints;

typedef struct
{
    dword firmwaregp;
    dword tapgp;
    dword unknown1;                         //tap malloc base address, before + 7ffe, & 0xFFFF8000
    type_TAPHeader *header;                 //after & 0xffff8000
    type_TAPEntryPoints *entryPoints;
    dword loadAddress;
    dword *currentDir;                      //pointer to this taps current directory ?
    dword zero;                             //exit flag
} type_TAPProcess;

enum
{
    oTAP_Hdd_ReadSectorDMA     = 0x00,  //undocumented - int TAP_Hdd_ReadSectorDMA(int startSector, word sectors, byte *buffer);    hdd related, called by debug functions 'rs', 'rc'     -- read sector?
    oTAP_Hdd_WriteSectorDMA    = 0x01,  //undocumented - int TAP_Hdd_WriteSectorDMA(int startSector, word sectors, byte *buffer);   hdd related, called by debug functions 'ws', 'wc'     -- write sector?
    oTAP_unknown2              = 0x02,  //undocumented - int TAP_unknown2(void);                                writes to eeprom @ 0xa3ffffe0, 0xa3ffffe1
    oTAP_Hdd_unknown3          = 0x03,  //undocumented - int TAP_Hdd_unknown3(int);                             ata related, ??? format ??? - more likely init()
    oTAP_Hdd_SetBookmark       = 0x04,
    oTAP_Hdd_GotoBookmark      = 0x05,
    oTAP_Hdd_ChangePlaybackPos = 0x06,
    oTAP_ControlEit            = 0x07,
    oTAP_SetBk                 = 0x08,
    oTAP_EPG_UpdateEvent       = 0x09,
    oTAP_EPG_DeleteEvent       = 0x0a,
    oTAP_EPG_GetExtInfo        = 0x0b,
    oTAP_Channel_IsStarted     = 0x0c,
    oTAP_Vfd_GetStatus         = 0x0d,
    oTAP_Vfd_Control           = 0x0e,
    oTAP_Vfd_SendData          = 0x0f,
    oTAP_Win_SetAvtice         = 0x10,
    oTAP_Win_SetDrawItemFunc   = 0x11,
    oTAP_GetTuner              = 0x12,  //undocumented - byte TAP_GetTuner(int mainSub);
    oTAP_Hdd_Move              = 0x13,  //undocumented - int TAP_Hdd_Move(char *from_dir, char *to_dir, char *filename);
    oTAP_Osd_unknown20         = 0x14,  //undocumented - int TAP_Osd_unknown20(dword *);        osd related, ???, variant of TAP_Osd_GetPlaneBaseInfo(&osdBaseInfo)
//v12.88 only
    oTAP_Channel_SwapMainSub   = 0x15,  //undocumented - int TAP_Channel_SwapMainSub(void);
};
extern void *(*TAP_GetSystemProc)(int id);
extern int   (*TAP_Hdd_ReadSectorDMA)(int mode, word, byte *buffer);
extern int   (*TAP_Hdd_WriteSectorDMA)(int mode, word, byte *buffer);
extern void  (*TAP_unknown2)(void);
extern int   (*TAP_Hdd_unknown3)(int);
extern byte  (*TAP_GetTuner)(int mainSub);
extern dword (*TAP_Hdd_Move)(char *from_dir, char *to_dir, char *filename);
extern int   (*TAP_Osd_unknown20)(dword *);
extern int   (*TAP_Channel_SwapMainSub)(void);

extern int  (*TAP_Channel_StopMainSub)(void);           //TAP_Channel_StopMainSub(), returns 1;
extern void (*TAP_undoc11)(int mode, int enable);       //disable/enable pop up [0=info,1=pip,2-volume,3=no signal]

//----------------------------------------------------------------------------
//
//firmware addresses
//
extern dword fw_tap_ident;
extern dword fw_tap_table;
extern dword fw_gp;
extern type_eventbuffer *fw_event_buffer;
extern type_eventtable *fw_event_table;
extern int fw_event_table_size;
extern int fw_max_events;
extern void *fw_event_delete;
extern void *fw_event_alloc;
extern dword *fw_mheg_entry;
extern void *fw_os_free;
extern type_taptime *fw_utc_time;
extern void *fw_shutdown_irq_disable;
extern void *fw_shutdown_task;

extern void *fw_enable_tshift;
extern void *fw_stop_tshift;
extern void *fw_mheg_disable;
extern void *fw_ioctl;
//----------------------------------------------------------------------------

#endif //_TOPFIELD_H_
